"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var View_1 = require("./View");
var React = require("react");
var react_native_1 = require("react-native");
var Theme_1 = require("../../modules/theme/Theme");
var BlurImage = (function (_super) {
    __extends(BlurImage, _super);
    function BlurImage() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    BlurImage.prototype.render = function () {
        var _a = this.props, children = _a.children, style = _a.style, props = __rest(_a, ["children", "style"]);
        return (React.createElement(View_1.default, { style: [styles.container, style] },
            React.createElement(react_native_1.Image, __assign({ style: [styles.image, style] }, props), children)));
    };
    return BlurImage;
}(React.Component));
exports.default = BlurImage;
var styles = react_native_1.StyleSheet.create({
    container: {
        backgroundColor: Theme_1.default.vars.blurImageBackgroundColor,
        overflow: 'hidden'
    },
    image: {
        backgroundColor: 'transparent',
        filter: 'blur(14px)',
        overflow: 'hidden',
        position: 'relative',
        opacity: 0.8
    }
});
