"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_native_1 = require("react-native");
var Link_1 = require("./Link");
var Theme_1 = require("../../modules/theme/Theme");
var HeaderAction = (function (_super) {
    __extends(HeaderAction, _super);
    function HeaderAction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HeaderAction.prototype.render = function () {
        var _a = this.props, style = _a.style, iconStyle = _a.iconStyle, props = __rest(_a, ["style", "iconStyle"]);
        return (React.createElement(Link_1.default, __assign({ style: [styles.link, style], iconStyle: [styles.icon, iconStyle] }, props)));
    };
    return HeaderAction;
}(React.Component));
exports.default = HeaderAction;
var styles = react_native_1.StyleSheet.create({
    link: {
        alignItems: 'center',
        justifyContent: 'center',
        padding: 4,
        marginLeft: 2,
        marginRight: 2
    },
    icon: {
        fontSize: 30,
        color: Theme_1.default.vars.headerActionIconColor
    }
});
