"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_native_1 = require("react-native");
var HeaderAction_1 = require("./HeaderAction");
var PropTypes = require('prop-types');
var HeaderDrawerActiion = (function (_super) {
    __extends(HeaderDrawerActiion, _super);
    function HeaderDrawerActiion() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            isMain: true
        };
        return _this;
    }
    HeaderDrawerActiion.prototype.toggle = function () {
        if (this.state.isMain) {
            this.context.drawer && this.context.drawer.toggle();
        }
        else {
            var history_1 = this.context.router.history;
            history_1.goBack();
        }
    };
    HeaderDrawerActiion.prototype.componentDidMount = function () {
        var history = this.context.router.history;
        if (react_native_1.Platform.OS !== 'web') {
            var isMain = history.index === 0;
            this.setState({ isMain: isMain });
        }
    };
    HeaderDrawerActiion.prototype.render = function () {
        var props = __rest(this.props, []);
        var isMain = this.state.isMain;
        if (react_native_1.Platform.OS !== 'web') {
            return (React.createElement(HeaderAction_1.default, __assign({ icon: isMain ? 'menu' : 'arrow_back', onPress: this.toggle.bind(this) }, props)));
        }
        return (React.createElement(HeaderAction_1.default, __assign({ icon: 'menu', onPress: this.toggle.bind(this) }, props)));
    };
    return HeaderDrawerActiion;
}(React.Component));
HeaderDrawerActiion.contextTypes = {
    router: PropTypes.object.isRequired,
    drawer: PropTypes.object.isRequired
};
exports.default = HeaderDrawerActiion;
var styles = react_native_1.StyleSheet.create({
    icon: {}
});
