/// <reference types="react" />
import * as React from 'react';
import { TextStyle, ViewStyle } from 'react-native';
export interface LabelProps {
    title?: string;
    hideIcon?: boolean;
    style?: ViewStyle;
    textStyle?: TextStyle;
    type?: 'default' | 'primary' | 'danger' | 'warning' | 'info' | 'success';
    size?: 'default' | 'small' | 'medium' | 'large';
    onPress?: () => void;
}
export interface State {
}
export default class Label extends React.Component<LabelProps, State> {
    render(): JSX.Element;
}
