/// <reference types="react" />
import * as React from 'react';
import { Message } from './MessageItem';
export interface MessageCenterProps {
    topOffset?: number;
}
export interface State {
    messages: Message[];
}
export default class MessageCenter extends React.Component<MessageCenterProps, State> {
    static counter: number;
    state: {
        messages: never[];
    };
    refs: {
        [string: string]: any;
    };
    show(params: Message): Promise<string>;
    remove(id: string): void;
    onHideItem(id: string): void;
    render(): JSX.Element;
}
