/// <reference types="react" />
import * as React from 'react';
import { ConfirmModal, Modal } from './ModalItem';
import { ActionModal } from './ModalActionItem';
export interface BaseModal {
    id?: string;
}
export interface ModalCenterProps {
}
export interface State {
    modals: BaseModal[];
}
export default class ModalCenter extends React.Component<ModalCenterProps, State> {
    static counter: number;
    state: {
        modals: never[];
    };
    refs: {
        [string: string]: any;
    };
    showAction(params: ActionModal): Promise<string>;
    showConfirm(params: ConfirmModal): Promise<string>;
    showDefault(params: Modal): Promise<string>;
    remove(id: string): void;
    onHideItem(id: string): void;
    render(): JSX.Element | null;
    private show(params);
}
