"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_native_1 = require("react-native");
var ModalItem_1 = require("./ModalItem");
var View_1 = require("./View");
var Translator_1 = require("../../modules/i18n/Translator");
var ModalActionItem_1 = require("./ModalActionItem");
var ModalCenter = (function (_super) {
    __extends(ModalCenter, _super);
    function ModalCenter() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            modals: []
        };
        return _this;
    }
    ModalCenter.prototype.showAction = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.show(__assign({}, params))];
            });
        });
    };
    ModalCenter.prototype.showConfirm = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var id, onSuccess, onCancel, title, actionConfirm, actionCancel, extra;
            return __generator(this, function (_a) {
                ModalCenter.counter++;
                id = ModalCenter.counter.toString();
                if (params.id) {
                    id = params.id;
                }
                onSuccess = params.onSuccess, onCancel = params.onCancel, title = params.title, actionConfirm = params.actionConfirm, actionCancel = params.actionCancel, extra = __rest(params, ["onSuccess", "onCancel", "title", "actionConfirm", "actionCancel"]);
                return [2 /*return*/, this.show(__assign({ id: id, title: title || Translator_1._('Are you sure?'), actions: [
                            {
                                type: 'primary',
                                title: actionConfirm || Translator_1._('Yes'),
                                onPress: function () {
                                    if (typeof onSuccess === 'function') {
                                        onSuccess();
                                    }
                                    _this.onHideItem(id);
                                }
                            },
                            {
                                title: actionCancel || Translator_1._('No'),
                                onPress: function () {
                                    if (typeof onCancel === 'function') {
                                        onCancel();
                                    }
                                    _this.onHideItem(id);
                                }
                            }
                        ] }, extra))];
            });
        });
    };
    ModalCenter.prototype.showDefault = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.show(params)];
            });
        });
    };
    ModalCenter.prototype.remove = function (id) {
        var modals = this.state.modals.filter(function (item) {
            return item.id !== id;
        });
        this.setState({ modals: modals });
    };
    ModalCenter.prototype.onHideItem = function (id) {
        var _this = this;
        var modalRef = this.refs["modal" + id];
        if (modalRef) {
            modalRef.hide(function () {
                _this.remove(id);
            });
        }
    };
    ModalCenter.prototype.render = function () {
        var _this = this;
        var modals = this.state.modals;
        if (modals.length < 1) {
            return null;
        }
        return (React.createElement(View_1.default, { style: [styles.container] }, modals.map(function (item, index) {
            if ('onReturn' in item) {
                var itemModal = item;
                return (React.createElement(ModalActionItem_1.default, { key: itemModal.id, ref: "modal" + itemModal.id, onHide: _this.onHideItem.bind(_this, itemModal.id), item: itemModal }));
            }
            else {
                return (React.createElement(ModalItem_1.default, { key: item.id, ref: "modal" + item.id, onHide: _this.onHideItem.bind(_this, item.id), item: item }));
            }
        })));
    };
    ModalCenter.prototype.show = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var modals, exist;
            return __generator(this, function (_a) {
                ModalCenter.counter++;
                if (!params.id) {
                    params.id = ModalCenter.counter.toString();
                }
                modals = this.state.modals;
                exist = modals.some(function (modal) {
                    return params.id === modal.id;
                });
                if (!exist) {
                    modals = modals.concat([params]);
                }
                else {
                    modals = modals.map(function (modal) {
                        if (params.id === modal.id) {
                            return params;
                        }
                        return modal;
                    });
                }
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        _this.setState({ modals: modals }, function () {
                            resolve(params.id);
                        });
                    })];
            });
        });
    };
    return ModalCenter;
}(React.Component));
ModalCenter.counter = 0;
exports.default = ModalCenter;
var styles = react_native_1.StyleSheet.create({
    container: {
        overflow: 'hidden',
        zIndex: 100,
        elevation: 10,
        justifyContent: 'center',
        //flex: 1,
        //position: Platform.OS === 'web' ? 'fixed' : 'absolute',
        position: 'absolute',
        right: 0,
        left: 0,
        top: 0,
        bottom: 0
    }
});
