/// <reference types="react" />
import * as React from 'react';
import { ViewStyle } from 'react-native';
import { ButtonProps } from './Button';
export interface PanelProps {
    title: string | JSX.Element;
    actions?: PanelAction[];
    toolbarHeight?: number;
    children?: JSX.Element | JSX.Element[];
    style?: ViewStyle;
}
export interface PanelAction extends ButtonProps {
    title?: string;
    onPress: () => void;
}
export interface State {
}
export default class Panel extends React.Component<PanelProps, State> {
    render(): JSX.Element;
}
