export declare type Name = 'onLocaleChange' | 'onThemeChange' | 'onLocationChange' | 'onDimensionsChange' | 'onOrientationChange' | 'onNoLogin' | 'onNetworkStateChange' | 'onSuccessLogin' | string;
export default class Emitter {
    static emit(name: Name, data: any): boolean;
    static on(name: Name, callback: Function): string;
    static off(callback: string): void;
}
