"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var PubSub = require('pubsub-js');
var Emitter = (function () {
    function Emitter() {
    }
    Emitter.emit = function (name, data) {
        return PubSub.publish(name, data);
    };
    Emitter.on = function (name, callback) {
        return PubSub.subscribe(name, function (name, data) {
            callback(data);
        });
    };
    Emitter.off = function (callback) {
        return PubSub.unsubscribe(callback);
    };
    return Emitter;
}());
exports.default = Emitter;
