export declare type NetworkType = 'OFF' | 'WIFI' | 'MOBILE' | 'UNKNOWN';
export default class Network {
    protected static isReady: boolean;
    private static last;
    private static changeListener;
    private static checkAppStateBinded;
    static init(): void;
    static destroy(): void;
    static isConnected(): boolean;
    static getType(): NetworkType;
    static updateNetworkType(): Promise<NetworkType>;
    protected static checkAppState(newState: string): void;
    protected static parse(reach: string): NetworkType;
    protected static stateChange(reach: string): Promise<NetworkType>;
}
