export declare type Orientation = 'PORTRAIT' | 'LANDSCAPE' | string;
export interface Dimensions {
    width: number;
    height: number;
    scale: number;
    fontScale: number;
}
export default class ScreenWeb {
    private static dimensions;
    private static last;
    private static first;
    private static handleResizeBinded;
    private static listener;
    static init(): void;
    static destroy(): void;
    static getDimensions(): Dimensions;
    static getOrientation(): Orientation;
    static updateOrientation(): Promise<Orientation>;
    static updateDimensions(): Promise<Dimensions>;
    private static getWidth();
    private static getHeight();
    private static getScreenDimensions();
    private static didUpdateDimensions();
    private static handleResize();
}
