export interface UserSettings {
    schemaVersion?: number;
    path?: string;
}
export interface Settings {
    schemaVersion: number;
    path: string;
}
export interface Cache {
    _id: string;
    value?: string;
}
export default class CacheStorageWeb {
    static settings: Settings;
    private static db;
    static init(settings: UserSettings): void;
    static set(key: string, value: any): Promise<boolean>;
    static get(key: string): Promise<any>;
    static remove(key: string): Promise<boolean>;
    private static hashCode(text);
}
