/// <reference types="react" />
/**
 * @flow
 */
import * as React from 'react';
import { Image, ImageStyle } from 'react-native';
import { ImageProps } from './Image';
export interface BlurImageProps extends ImageProps {
    style?: ImageStyle;
}
export interface State {
    viewRef: any;
}
export default class BlurImageAndroid extends React.Component<BlurImageProps, State> {
    state: {
        viewRef: null;
    };
    refs: {
        [string: string]: any;
        input: Image;
    };
    private viewRef;
    imageLoaded(): void;
    render(): JSX.Element;
}
