"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var View_1 = require("./View");
/**
 * @flow
 */
var React = require("react");
var react_native_1 = require("react-native");
var react_native_blur_1 = require("react-native-blur");
var Theme_1 = require("../../modules/theme/Theme");
var BlurImageAndroid = (function (_super) {
    __extends(BlurImageAndroid, _super);
    function BlurImageAndroid() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            viewRef: null
        };
        return _this;
    }
    BlurImageAndroid.prototype.imageLoaded = function () {
        this.setState({ viewRef: react_native_1.findNodeHandle(this.refs.backgroundImage) });
    };
    BlurImageAndroid.prototype.render = function () {
        var _a = this.props, style = _a.style, children = _a.children, props = __rest(_a, ["style", "children"]);
        var viewRef = this.state.viewRef;
        return (React.createElement(View_1.default, { style: [styles.container, style] },
            React.createElement(react_native_1.Image, __assign({ style: [styles.container, style], ref: 'backgroundImage', onLoadEnd: this.imageLoaded.bind(this) }, props)),
            viewRef &&
                React.createElement(react_native_blur_1.BlurView, { blurRadius: 2, downsampleFactor: 10, overlayColor: Theme_1.default.vars.blurImageOverlayBackgroundColor, style: styles.blurView, viewRef: viewRef }),
            children));
    };
    return BlurImageAndroid;
}(React.Component));
exports.default = BlurImageAndroid;
var styles = react_native_1.StyleSheet.create({
    container: {
        backgroundColor: 'transparent'
    },
    blurView: {
        position: 'absolute',
        left: 0,
        top: 0,
        bottom: 0,
        right: 0
    }
});
