/// <reference types="react" />
import * as React from 'react';
import { TextStyle, ViewStyle } from 'react-native';
import { TouchableProps } from './Touchable';
export interface ButtonProps extends TouchableProps {
    title?: string;
    isLoading?: boolean;
    icon?: string;
    style?: ViewStyle;
    iconStyle?: TextStyle;
    textStyle?: TextStyle;
    iconPosition?: 'before' | 'after';
    type?: 'default' | 'primary' | 'danger' | 'warning' | 'info' | 'success';
    size?: 'default' | 'small' | 'medium' | 'large';
    onPress: () => void;
}
export interface State {
}
export default class Button extends React.Component<ButtonProps, State> {
    render(): JSX.Element;
}
