/// <reference types="react" />
import * as React from 'react';
import { HeaderActionProps } from './HeaderAction';
export interface HeaderProps {
    left?: HeaderActionProps | JSX.Element;
    right?: HeaderActionProps | JSX.Element;
    children?: JSX.Element;
    maxWidth?: number;
    statusBarBackgroundColor?: string;
    statusBarStyle?: 'default' | 'light-content';
    title: string | JSX.Element;
    actions?: HeaderActionProps[];
}
export interface State {
}
export default class Header extends React.Component<HeaderProps, State> {
    render(): JSX.Element;
}
