/// <reference types="react" />
import * as React from 'react';
import { TextStyle, ViewStyle } from 'react-native';
import { TouchableProps } from './Touchable';
export interface LinkProps extends TouchableProps {
    title?: string;
    isLoading?: boolean;
    icon?: string;
    style?: ViewStyle;
    iconStyle?: TextStyle;
    textStyle?: TextStyle;
    iconPosition?: 'before' | 'after';
    size?: 'default' | 'small' | 'medium' | 'large';
    onPress?: () => void;
}
export interface State {
}
export default class Link extends React.Component<LinkProps, State> {
    render(): JSX.Element;
}
