export interface UserSettings {
    analyticsId: string;
    appName?: string;
}
export interface Settings {
    analyticsId: string;
    appName: string;
}
export default class AnalyticsWeb {
    static settings: Settings;
    private static isLoaded;
    static init(settings: UserSettings): void;
    static screenView(path: string): void;
    static event(params: EventObject): void;
}
export interface EventObject {
    eventCategory: string;
    eventAction: string;
    eventLabel?: string;
    eventValue?: number;
    nonInteraction?: boolean;
}
