export interface UserSettings {
    messageTitle?: string;
    messageDescription?: string;
}
export interface Settings {
    messageTitle: string;
    messageDescription: string;
}
export default class Geolocation {
    static settings: Settings;
    private static lastPosition;
    private static initialPosition;
    private static watchID;
    static init(settings?: UserSettings): void;
    static getPosition(): Coordinates;
    static checkWatcher(forced?: boolean): Promise<void>;
    static destroy(): void;
    static updateLocation(): Promise<Coordinates>;
    protected static initWatcher(): Promise<void>;
    private static requestPermission();
    private static isAllowedToCheck();
}
