export declare type NetworkType = 'OFF' | 'WIFI' | 'MOBILE' | 'UNKNOWN';
export default class NetworkWeb {
    private static last;
    private static onOnlineListener;
    private static onOfflineListener;
    static init(): void;
    static destroy(): void;
    static isConnected(): boolean;
    static getType(): NetworkType;
    static updateNetworkType(): Promise<NetworkType>;
    private static onOnline();
    private static onOffline();
}
