export declare type Orientation = 'PORTRAIT' | 'LANDSCAPE' | string;
export interface Dimensions {
    width: number;
    height: number;
    scale: number;
    fontScale: number;
}
export default class Screen {
    private static dimensions;
    private static last;
    private static first;
    private static checkAppStateBinded;
    private static updateDimensionsBinded;
    static init(): void;
    static getDimensions(): Dimensions;
    static getOrientation(): Orientation;
    static destroy(): void;
    static updateOrientation(): Promise<Orientation>;
    static updateDimensions(): Promise<Dimensions>;
    private static didUpdateDimensions(update);
    private static checkAppState(newState);
    private static orientationChange(orientation);
    private static getScreenDimensions();
}
