"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function StyleList() {
    var styles = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        styles[_i] = arguments[_i];
    }
    var styleList = [];
    for (var _a = 0, styles_1 = styles; _a < styles_1.length; _a++) {
        var style = styles_1[_a];
        if (style instanceof Array) {
            styleList.push.apply(styleList, style);
        }
        else if (style) {
            styleList.push(style);
        }
    }
    return styleList;
}
exports.default = StyleList;
